%define dbus_glib_version 0.70
%define dbus_version 1.0
%define glib2_version 2.16.0
%define gnome_doc_utils_version 0.8.0
%define gnome_icon_theme_version 2.19.91
%define gnome_pilot_version 2.0.15
%define gtk2_version 2.14.0
%define gtkhtml_version 3.25.3
%define intltool_version 0.35.5
%define libgweather_version 2.25.4
%define orbit2_version 2.9.8
%define pilot_link_version 2:0.12.1
%define scrollkeeper_version 0.1.4
%define soup_version 2.2.2

%define evo_major 2.28

%define exchange_support 1
%define inline_audio_support 1
%define ldap_support 1
%define libnotify_support 1
%define krb5_support 1
%define nntp_support 1
%define nm_support 0
%define use_mozilla_nss 1

# Use stricter build settings than required by upstream.
%define strict_build_settings 1

%define evo_plugin_dir %{_libdir}/evolution/%{evo_major}/plugins

### Abstract ###

Name: evolution-anjal
Version: 2.27.5~20090724
Release: 1.6.moblin2
Group: Applications/Productivity
Summary: Mail and calendar client for GNOME
License: GPLv2+ and GFDL
URL: http://projects.gnome.org/evolution/
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Source: %{name}-%{version}.tar.bz2

### Patches ###


# RH bug #176400
Patch12: evolution-2.9.1-im-context-reset.patch

# Anjal specific patch
Patch13: moblin-strip-down-evolution-for-anjal.patch
Patch20: revert-using-system-timezone.patch

## Dependencies ###

Requires(post): GConf2
Requires(post): scrollkeeper >= %{scrollkeeper_version}
Requires(postun): scrollkeeper >= %{scrollkeeper_version}

# Don't trust evolution-data-server to maintain accurate sonames.
Requires: evolution-data-server-dbus >= 2.25.91

Requires: gnome-icon-theme >= %{gnome_icon_theme_version}
Requires: gnome-themes

### Build Dependencies ###

BuildRequires: GConf2-devel
BuildRequires: ORBit2-devel >= %{orbit2_version}
BuildRequires: atk-devel
BuildRequires: autoconf >= 2.59
BuildRequires: automake >= 1.9
BuildRequires: bison
BuildRequires: byacc
BuildRequires: dbus-devel >= %{dbus_version}
BuildRequires: dbus-glib-devel >= %{dbus_glib_version}
BuildRequires: desktop-file-utils
BuildRequires: evolution-data-server-dbus-devel >= 2.25.91
BuildRequires: flex
BuildRequires: gettext
BuildRequires: glib2-devel >= %{glib2_version}
BuildRequires: gnome-common
BuildRequires: gnome-doc-utils >= %{gnome_doc_utils_version}
BuildRequires: gnutls-devel
BuildRequires: gtk2-devel >= %{gtk2_version}
BuildRequires: gtkhtml3-devel >= %{gtkhtml_version}
BuildRequires: gvfs
BuildRequires: intltool >= %{intltool_version}
BuildRequires: libgnomecanvas-devel >= 2.0
BuildRequires: libgnomeui-devel >= 2.0
BuildRequires: libgweather-devel >= %{libgweather_version}
BuildRequires: libsoup-devel >= %{soup_version}
BuildRequires: libtool >= 1.5
BuildRequires: libxml2-devel
BuildRequires: pkgconfig

%if %{use_mozilla_nss}
BuildRequires: nspr-devel
BuildRequires: nss-devel
%else
BuildRequires: openssl-devel
%endif

%if %{inline_audio_support}
# audio-inline plugin requires gstreamer to build:
BuildRequires: gstreamer-devel
%endif

%if %{ldap_support} 
BuildRequires: openldap-devel >= 2.0.11 
%endif

%if %{krb5_support} 
BuildRequires: krb5-devel 
# tweak for krb5 1.2 vs 1.3
%define krb5dir /usr/kerberos
#define krb5dir `pwd`/krb5-fakeprefix
%endif

%if %{nm_support}
BuildRequires: NetworkManager-glib-devel
%endif

%if %{libnotify_support}
BuildRequires: libnotify-devel
%endif

%description
Evolution is the GNOME mailer, calendar, contact manager and
communications tool.  The components which make up Evolution
are tightly integrated with one another and act as a seamless
personal information-management tool.

%package devel
Group: Development/Libraries
Summary: Development files for building against %{name}
Requires: %{name} = %{version}-%{release}
Requires: evolution-data-server-dbus >= 2.25.91
Requires: gtk2-devel >= %{gtk2_version}
Requires: gtkhtml3-devel >= %{gtkhtml_version}
Requires: libgweather-devel >= %{libgweather_version}
Requires: libsoup-devel >= %{soup_version}
Requires: libxml2-devel

%description devel
Development files needed for building things which link against
%{name}.

%prep
%setup -q
%patch12 -p1 -b .im-context-reset
%patch13 -p1 -b .moblin-strip-down-evolution-for-anjal
%patch20 -p1

mkdir -p krb5-fakeprefix/include
mkdir -p krb5-fakeprefix/lib
mkdir -p krb5-fakeprefix/%{_lib}

%build
# define all of our flags, this is kind of ugly :(
%if %{ldap_support}
%define ldap_flags --with-openldap=yes
%else
%define ldap_flags --without-openldap
%endif

%define pilot_flags --disable-pilot-conduits

%if %{krb5_support}
%define krb5_flags --with-krb5=%{krb5dir}
%else
%define krb5_flags --without-krb5
%endif

%if %{nntp_support}
%define nntp_flags --enable-nntp
%else
%define nntp_flags --disable-nntp
%endif

%if %{use_mozilla_nss}
%define ssl_flags --enable-nss=yes --disable-smime
%else
%define ssl_flags --enable-openssl=yes
%endif

%if %{use_mozilla_nss}
if ! pkg-config --exists nss; then 
  echo "Unable to find suitable version of mozilla nss to use!"
  exit 1
fi
%endif

%if %{exchange_support}
%define exchange_flags --enable-exchange
%else
%define exchange_flags --disable-exchange
%endif

CPPFLAGS="-I%{_includedir}/et"; export CPPFLAGS
CFLAGS="$RPM_OPT_FLAGS -fPIC -DLDAP_DEPRECATED -I%{_includedir}/et -Wno-sign-compare"; export CFLAGS
%if ! %{use_mozilla_nss}
if pkg-config openssl ; then
	CFLAGS="$CFLAGS `pkg-config --cflags openssl`"
	LDFLAGS="$LDFLAGS `pkg-config --libs-only-L openssl`"
fi
%endif

# Add stricter build settings here as the source code gets cleaned up.
# We want to make sure things like compiler warnings and avoiding deprecated
# functions in the GNOME/GTK+ libraries stay fixed.
#
# Please file a bug report at bugzilla.gnome.org if these settings break
# compilation, and encourage the upstream developers to use them.

%if %{strict_build_settings}
CFLAGS="$CFLAGS \
	-DG_DISABLE_DEPRECATED=1 \
	-DPANGO_DISABLE_DEPRECATED=1 \
	-DGDK_PIXBUF_DISABLE_DEPRECATED=1 \
	-DGDK_DISABLE_DEPRECATED=1 \
	-DEDS_DISABLE_DEPRECATED=1 \
	-Wdeclaration-after-statement \
	-Werror-implicit-function-declaration"
# TODO: Make -DCAMEL_DISABLE_DEPRECATED work.
%endif

# Moblin has no NetworkManager so "--disable-nm"
%autogen \
	--with-sub-version=" (%{version}-%{release})" \
	--with-kde-applnk-path=no \
	--without-help \
	--disable-nm \
	%ldap_flags %pilot_flags %krb5_flags \
	%nntp_flags %ssl_flags %exchange_flags
export tagname=CC
make %{?_smp_mflags} LIBTOOL=/usr/bin/libtool CFLAGS="$CFLAGS -UGNOME_DISABLE_DEPRECATED -fno-strict-aliasing"

# Remove the welcome email from Novell
rm -rf mail/default

# Disable this for fast testing build cycles

# Strip unneeded translations from .mo files.
# This reduces the RPM size by several megabytes.
#cd po
#grep -v ".*[.]desktop[.]in[.]in$\|.*[.]server[.]in[.]in$\|.*[.]schemas[.]in$" POTFILES.in > POTFILES.keep
#mv POTFILES.keep POTFILES.in
#intltool-update --pot
#for p in *.po; do
#	msgmerge $p evolution-%{evo_major}.pot > $p.out
#	msgfmt -o `basename $p .po`.gmo $p.out
#done
#cd -

%install
rm -rf $RPM_BUILD_ROOT
export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
export tagname=CC
make LIBTOOL=/usr/bin/libtool DESTDIR=$RPM_BUILD_ROOT install
unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL

# remove libtool archives for importers and the like
find $RPM_BUILD_ROOT/%{_libdir}/evolution -name '*.la' -exec rm {} \;

# remove statically built libraries:
find $RPM_BUILD_ROOT/%{_libdir}/evolution -name '*.a' -exec rm {} \;

# pilot conduits static and libtool bits should go away too
rm -f $RPM_BUILD_ROOT/%{_libdir}/gnome-pilot/conduits/*.a
rm -f $RPM_BUILD_ROOT/%{_libdir}/gnome-pilot/conduits/*.la

# remove additional things we don't want
%if ! %{inline_audio_support}
%{__rm} -f $RPM_BUILD_ROOT%{evo_plugin_dir}/org-gnome-audio-inline.eplug \
	$RPM_BUILD_ROOT%{evo_plugin_dir}/liborg-gnome-audio-inline.so
%endif

# scrollkeeper gets handled in %post
rm -rf $RPM_BUILD_ROOT/var/lib/scrollkeeper

rm -f $RPM_BUILD_ROOT%{_datadir}/mime-info/evolution.keys
rm -f $RPM_BUILD_ROOT%{_datadir}/mime-info/evolution.mime

%find_lang evolution-%{evo_major} --all-name --with-gnome

grep "/usr/share/locale" evolution-%{evo_major}.lang > translations.lang

# Original Fedora RPM SPEC has some instructions to
# Replace identical images in the help by links.
# This reduces the RPM size by several megabytes.
# Moblin doesn't ship those images so they are removed.

%post
/sbin/ldconfig
scrollkeeper-update -q
touch --no-create %{_datadir}/icons/hicolor || :
%{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule %{_sysconfdir}/gconf/schemas/evolution-mail.schemas > /dev/null

%postun
/sbin/ldconfig
scrollkeeper-update -q
touch --no-create %{_datadir}/icons/hicolor || :
%{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :

%clean
rm -rf $RPM_BUILD_ROOT

%files -f translations.lang
%defattr(-, root, root)
%doc AUTHORS COPYING ChangeLog NEWS README

# GConf schemas:
%config(noreplace) %{_sysconfdir}/gconf/schemas/evolution-mail.schemas

# The main executable is not needed in Moblin
#%{_bindir}/evolution

# Desktop files is not needed in Moblin
#%{_datadir}/applications/evolution.desktop

# Icons:
%{_datadir}/icons/hicolor/16x16/apps/
%{_datadir}/icons/hicolor/22x22/apps/
%{_datadir}/icons/hicolor/24x24/apps/
%{_datadir}/icons/hicolor/32x32/apps/
%{_datadir}/icons/hicolor/48x48/apps/
%{_datadir}/icons/hicolor/scalable/apps/

# The main data directory
# (have not attempted to split this up into an explicit list)
%dir %{_datadir}/evolution
%{_datadir}/evolution/%{evo_major}

# Shared libraries:
%{_libdir}/evolution/%{evo_major}/libeconduit.so.*
%{_libdir}/evolution/%{evo_major}/libefilterbar.so.*
%{_libdir}/evolution/%{evo_major}/libemiscwidgets.so.*
%{_libdir}/evolution/%{evo_major}/libetable.so.*
%{_libdir}/evolution/%{evo_major}/libetext.so.*
%{_libdir}/evolution/%{evo_major}/libetimezonedialog.so.*
%{_libdir}/evolution/%{evo_major}/libeutil.so.*
%{_libdir}/evolution/%{evo_major}/libevolution-a11y.so.*
%{_libdir}/evolution/%{evo_major}/libevolution-addressbook-a11y.so.*
%{_libdir}/evolution/%{evo_major}/libevolution-calendar-a11y.so.*
%{_libdir}/evolution/%{evo_major}/libevolution-widgets-a11y.so.*
%{_libdir}/evolution/%{evo_major}/libfilter.so.*
%{_libdir}/evolution/%{evo_major}/libmenus.so.*
%{_libdir}/evolution/%{evo_major}/libevolution-mail-shared.so.*

%files devel
%defattr(-, root, root)
%{_includedir}/evolution-%{evo_major}
%{_libdir}/pkgconfig/evolution-plugin.pc
%{_libdir}/pkgconfig/evolution-shell.pc
%{_libdir}/evolution/%{evo_major}/libeconduit.so
%{_libdir}/evolution/%{evo_major}/libefilterbar.so
%{_libdir}/evolution/%{evo_major}/libemiscwidgets.so
%{_libdir}/evolution/%{evo_major}/libetable.so
%{_libdir}/evolution/%{evo_major}/libetext.so
%{_libdir}/evolution/%{evo_major}/libetimezonedialog.so
%{_libdir}/evolution/%{evo_major}/libeutil.so
%{_libdir}/evolution/%{evo_major}/libevolution-a11y.so
%{_libdir}/evolution/%{evo_major}/libevolution-addressbook-a11y.so
%{_libdir}/evolution/%{evo_major}/libevolution-calendar-a11y.so
%{_libdir}/evolution/%{evo_major}/libevolution-widgets-a11y.so
%{_libdir}/evolution/%{evo_major}/libfilter.so
%{_libdir}/evolution/%{evo_major}/libmenus.so
%{_libdir}/evolution/%{evo_major}/libevolution-mail-shared.so
%changelog
* Fri Jul 24 2009 Yan Li <yan.i.li@intel.com> 2.27.5~20090724
- Updated to latest git tip
- Fixed defect: Closing a message tab, Anjal crash (possibility: 50%%)
  (#4666)
* Thu Jul 23 2009 Yan Li <yan.i.li@intel.com> 2.27.5~20090723
- Updated to latest git tip
* Tue Jul 21 2009 Yan Li <yan.i.li@intel.com> 2.27.5~20090721
- Updated to latest git tip
* Mon Jul 20 2009 Yan Li <yan.i.li@intel.com> 2.27.5~20090720
- Updated to latest git tip per discussion with upstream developer to
  pull in latest changes for supporting status toolbar in Anjal
- Dropped patches already in upstream tarball:
  fix-novell-bug-519663.a2b1510a.patch
  Search-bar-stuff-for-Anjal.52c69585.patch
* Fri Jul 17 2009 Yan Li <yan.i.li@intel.com> 2.27.4.1
- Updated to latest beta release (2.27.4.1), dropped the following
  patches that were already in upstream tarball:
  fix-gnome-bug-588534.110c6af2.patch
  fix-gnome-bug-588534.c6f885ef.patch
  fix-moblin-bug-3757.9ba45697.patch
  fix-moblin-bug-3983.70c799f3-ecf403c2.patch
- Fixed defect: Autodetect email should go to last (Novell Bugzilla
  [#519663])
- Backported new search bar for Anjal from upstream (patch
  Search-bar-stuff-for-Anjal.52c69585.patch)
* Wed Jul 15 2009 Yan Li <yan.i.li@intel.com> 2.27.4
- Fixed defect: Account wizard hides part of username (GNOME Bugzilla
  [#588534])
* Tue Jul 14 2009 Yan Li <yan.i.li@intel.com> 2.27.4
- Updated to latest beta release
- Fixed: Need a new "Select Contacts" dialog for Anjal (#3983)
- Fixed: Can't set port number to connect to secure POP3/SMTP servers
  (like Gmail) (#3757)
* Thu Jul  2 2009 Yan Li <yan.i.li@intel.com> 2.27.3~20090703
- Updated to latest git tip
- SPEC file cleaned up, fixed many RPMLINT warnings
- Evolution's help files are useless for Anjal, don't build the help
  package
* Thu Jun 25 2009 Yan Li <yan.i.li@intel.com> 2.27.3~20090625
- Updated to latest git tip
* Wed Jun 17 2009 Damien Lespiau <damien.lespiau@intel.com> 2.27.3~20090617
- Refresh git snapshot (as requested by Srinivasa Ragavan)
- Enable SSL support
- Refresh the stripping patch, disable SMIME support for now
* Tue Jun  9 2009 Damien Lespiau <damien.lespiau@intel.com> 2.27.2~20090609
- This package craft a special striped down evolution (part of its libs)
  for Anjal
* Thu Mar 26 2009 Anas Nashif <anas.nashif@intel.com> 2.25.92
- Initial import into Moblin based on Fedora SPEC file
